--------------------------------------------------------------------------------
-- Weapon water baloone
-- Original Carnage Contest Weapon inspired
-- Script by DC, August 2009, www.UnrealSoftware.de
-- Edited by Thecode,September 2010
--------------------------------------------------------------------------------

-- Setup Tables
if thecode==nil then thecode={} end
thecode.waterbaloone={}

-- Load & Prepare Ressources
thecode.waterbaloone.gfx_wpn0=loadgfx("weapons/waterbaloone0.png")						-- Weapon Image
setmidhandle(thecode.waterbaloone.gfx_wpn0)
thecode.waterbaloone.gfx_wpn1=loadgfx("weapons/waterbaloone1.png")	
setmidhandle(thecode.waterbaloone.gfx_wpn1)
thecode.waterbaloone.sfx_attack=loadsfx("waterbaloone.ogg")							-- Attack Sound

--------------------------------------------------------------------------------
-- Weapon: Pogo Stick
--------------------------------------------------------------------------------

thecode.waterbaloone.id=addweapon("thecode.waterbaloone","Water baloone",thecode.waterbaloone.gfx_wpn0,1)	-- Add Weapon (1 use)


function thecode.waterbaloone.draw()												-- Draw
	if weapon_mode==1 then
		-- Draw
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(-getplayerdirection(0),1)
		setrotation(0)
		particle(p_ring,getplayerx(0),getplayery(0))
		particlespeed(800,800)
		particlefadealpha(0.01)
		particlecolor(0,255,0)
		particle(p_ring,getplayerx(0),getplayery(0))
		particlefadealpha(0.04)
		particlecolor(0,255,0)
		hudinfo("Hit [Space] again to deactivate the Water baloone")
	elseif weapon_shots==0 then
	
		hudinfo("Hit [Space] once to activate the Water baloone")
		
	end
end

function thecode.waterbaloone.attack(attack)										-- Attack

	if weapon_timer>0 then
		weapon_timer=weapon_timer-1
	end
	-- Activate / Deactive
	if (attack==1) and weapon_timer<=0 then
		weapon_timer=10
		if weapon_shots==0 then
			weapon_mode=1
			weapon_shots=1
			useweapon(1)
		else
			weapon_mode=0
		end
	end
	-- Super Jump Power!
	if (weapon_mode==1) then
	
	if getplayery(0)>=getwatery()-55 then

		particle(p_ring,getplayerx(0),getplayery(0))
		particlealpha(1.0)
		particlespeed(800,800)
		particlecolor(0,255,0)
		particlesize(20,20)
		particlefadealpha(0.009)
		
		particle(p_waterhit,getplayerx(0),getplayery(0))
			if math.random(1,2)==1 then
				playsound(sfx_hitwater2)
			else
				playsound(sfx_hitwater3)
			end
			
			playerposition(0,getplayerx(0),getwatery()-55)
			playsound(sfx_splatter1)
			playerpush(0,getplayerdirection(0)*1.0,-7.0,1,0)
			playsound(thecode.waterbaloone.sfx_attack)
	end
		-- Avoid Falldamage
		if getplayeryspeed(0)>7.0 then
			playerpush(0,getplayerxspeed(0),7.0,1,0)
		end
		-- Timeout (disable stick)
		if getframesleft()<=1 then
			weapon_mode=2
		end
	end
end
