--------------------------------------------------------------------------------
-- Weapon breaker + Projectile breaker

-- Script by Thecode,September 2010.
--------------------------------------------------------------------------------

-- Setup Tables
if thecode==nil then thecode={} end
thecode.breaker={}
thecode.breaker.breaker={}

-- Load & Prepare Ressources
thecode.breaker.gfx_wpn=loadgfx("weapons/breaker.png")							-- Weapon Image
setmidhandle(thecode.breaker.gfx_wpn)
thecode.breaker.gfx_pro=loadgfx("weapons/breaker.png")						-- Projectile Image
setmidhandle(thecode.breaker.gfx_pro)
thecode.breaker.sfx_hit=loadsfx("buildmetal.ogg")
thecode.breaker.sfx_dig=loadsfx("digger.wav")

---------------------------------------------------------------------------------
-- Weapon: breaker
--------------------------------------------------------------------------------

thecode.breaker.id=addweapon("thecode.breaker","Breaker",thecode.breaker.gfx_wpn,0,3)		-- Add Weapon (0 uses, first in round 3)

function thecode.breaker.draw()											-- Draw
	-- HUD Positioning
	if weapon_shots==0 then
		hudpositioning(pos_invisible)
	end
end

function thecode.breaker.attack(attack)									-- Attack
	if (weapon_shots<=0) and (weapon_position==1) then
		-- No more weapon switching!
		useweapon(0)
		
		weapon_shots=weapon_shots+1
		-- Attack
		pid=createprojectile(thecode.breaker.breaker.id)
		projectiles[pid]={}
		projectiles[pid].x=weapon_x
		projectiles[pid].y=-500
		projectiles[pid].sx=0
		projectiles[pid].sy=10
		-- End Turn
		endturn()
	end
end

--------------------------------------------------------------------------------
-- Projectile: breaker
--------------------------------------------------------------------------------

thecode.breaker.breaker.id=addprojectile("thecode.breaker.breaker")	-- Add Projectile

function thecode.breaker.breaker.draw(id)								-- Draw
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	setrotation(0)
	-- Draw projectile
	setblend(blend_alpha)
		setalpha(1)
		setrotation(0)
	drawimage(thecode.breaker.gfx_wpn,projectiles[id].x,projectiles[id].y)
	
	
end

function thecode.breaker.breaker.update(id)								-- Update
	-- Particle Tail
	
		particle(p_smoke,projectiles[id].x+math.random(-6,6),projectiles[id].y-7)
		particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
		particlefadealpha(0.05)
		particle(p_lightpuff,projectiles[id].x+math.random(-5,5),projectiles[id].y-5)
		particlefadealpha(0.04)
		particlecolor(255,255,255)
	
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/10)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		-- Collision / Water
		if collision(cc.armageddon.gfx_pro,projectiles[id].x,projectiles[id].y,1,1)==1 then
             projectiles[pid].sy=projectiles[pid].sy-0.4
		
		
		if projectiles[pid].sy<=0 then
		-- Free projectile
				freeprojectile(id)
				terrainexplosion(projectiles[id].x,projectiles[id].y,40,1)
		end
			-- Center
			playsound(thecode.breaker.sfx_dig)
			terraincircle(projectiles[id].x,projectiles[id].y,20,3,0x00000000)
			-- Fire
			
			if playercollision()~=0 then
		
				-- Cause damage
				playerdamage(playercollision(),0+math.random(0,100))
				terrainexplosion(projectiles[id].x,projectiles[id].y,50,1)
		-- Free projectile
				freeprojectile(id)
	end
			break
		end
		
	-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(thecode.firepgun.sfx_waterimpact)
			-- Free projectile
			freeprojectile(id)
			return 1
		end
	end
	-- Scroll to projectile
	scroll(projectiles[id].x+projectiles[pid].sx*9,projectiles[id].y+projectiles[pid].sy*9)
end

